var params = {
    "domain": "dss-installer",
    "locale_data": json_locale_data
};

var gt = new Gettext(params);

function _(msgid) {
    return gt.gettext(msgid);
}

Ext.namespace('dSS', 'dSS.time');

dSS.time.dateprint = function(date, month, year, hour, minute) {
    switch (month) {
    case 0:
        month = "Jan";
        break;
    case 1:
        month = "Feb";
        break;
    case 2:
        month = "Mar";
        break;
    case 3:
        month = "Apr";
        break;
    case 4:
        month = "May";
        break;
    case 5:
        month = "Jun";
        break;
    case 6:
        month = "Jul";
        break;
    case 7:
        month = "Aug";
        break;
    case 8:
        month = "Sep";
        break;
    case 9:
        month = "Oct";
        break;
    case 10:
        month = "Nov";
        break;
    case 11:
        month = "Dec";
        break;
    default:
        month = "";
        break;
    }

    if (hour < 10) hour = ('0' + hour);

    if (minute < 10) minute = ('0' + minute);

    return month + ' ' + date + ' ' + hour + ':' + minute + ', ' + year;
}

dSS.time.update = function() {
    var t = new Date(Date.now() - dSS.config.dSSTimeDiff);
    Ext.get('dssTime').update(dSS.time.dateprint(t.getDate(), t.getMonth(), t.getFullYear(), t.getHours(), t.getMinutes()
    ));
    setTimeout('dSS.time.update()', 1000);
}

Ext.namespace("dSS", "dSS.config");

Ext.onReady(function() {
    Ext.get('start').remove();
    dSS.config.dSSTimeDiff = 0;

    var viewport = new Ext.Viewport({
        layout: 'border',
        items: [
        {
            xtype: 'box',
            region: 'north',
            height: 80,
            autoEl: {
                tag: 'div',
                html: '<a href="http://digitalstrom.org/" alt="' + _("visit digitalSTROM.org") + '"><img id="logo" src="images/ds_logo.gif" alt="dS-Logo"></a>' + '<h1><a href="http://digitalstrom.org/" alt="visit digitalSTROM.org">' + _("digitalSTROM Server Overview") + '</a></h1>' + '<p><span id= \'dssVersion\'>-</span>, <span id=\'dssTime\'>-</span></p>'
            }
        },
        {
            region: 'center',
            xtype: 'panel',
            hideBorders: true,
            autoLoad: 'locale/de_DE/overview-links.html'
        }]
    });

    Ext.Ajax.request({
        url: "/json/system/version",
        disableCaching: true,
        success: function(response, options) {
            try {
                var data = Ext.decode(response.responseText);
                if (data.ok === false) {
                    throw new Ext.Error(_("Could not get dSS version!"), data.error);
                }
                Ext.get("dssVersion").update(data.message);

            } catch(error) {}
        },
        failure: function(response, options) {}
    });

    Ext.Ajax.request({
        url: "/json/system/time",
        disableCaching: true,
        scope: this,
        success: function(response, options) {
            try {
                var data = Ext.decode(response.responseText);
                if (data.ok === false) {
                    throw new Ext.Error(_("Could not get dSS time!"), data.error);
                }
                dSS.config.dSSTimeDiff = (Date.now() - (parseInt(data.message, 10) * 1000));
                dSS.time.update();

            } catch(error) {}
        },
        failure: function(response, options) {}
    });

});

